import { Express } from 'express';
import { AwilixContainer } from 'awilix';
import { Type } from './core';
declare global {
    type ExpressApp = Express;
}
/**
 * Load medusa and apply all components
 */
export declare class Medusa {
    #private;
    /**
     * @param rootDir Directory where the `medusa-config` is located
     * @param express Express instance
     */
    constructor(rootDir: string, express: Express);
    /**
     * @param modules The modules to load into medusa
     */
    load(modules: Type[]): Promise<AwilixContainer>;
}
