"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEntityTemplate = void 0;
const dedent = require("dedent");
/**
 * Provide a basic template for the entity component generation.
 * @param entityName
 */
function getEntityTemplate(entityName) {
    return dedent `
        import { Column, Entity } from "typeorm"; 
        import { Entity as MedusaEntity } from "medusa-extender";
        
        @MedusaEntity()
        @Entity()
        export class ${entityName.replace('Entity', '')} {
            @Column()
            name: string;
        }
    `;
}
exports.getEntityTemplate = getEntityTemplate;
//# sourceMappingURL=entity-template.js.map