"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMiddlewareTemplate = void 0;
const dedent = require("dedent");
/**
 * Provide a basic template for the middleware component generation.
 * @param middlewareName
 */
function getMiddlewareTemplate(middlewareName) {
    return dedent `
        import { 
            Middleware,
            MedusaMiddleware,
            MedusaAuthenticatedRequest
        } from 'medusa-extender';
        import { NextFunction, Response } from 'express';
        
        @Middleware({ requireAuth: true, routes: [{ method: '', path: '' }] })
        export class ${middlewareName} implements MedusaMiddleware {
            public consume(req: MedusaAuthenticatedRequest, res: Response, next: NextFunction): void | Promise<void> {
                return next();
            }
        }
    `;
}
exports.getMiddlewareTemplate = getMiddlewareTemplate;
//# sourceMappingURL=middleware-template.js.map