"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMigrationTemplate = void 0;
const dedent = require("dedent");
/**
 * Provide a basic template for the migration component generation.
 * @param migrationName
 * @param timestamp
 */
function getMigrationTemplate(migrationName, timestamp) {
    return dedent `
        import { MigrationInterface, QueryRunner } from 'typeorm';
        import { Migration } from 'medusa-extender';
        
        @Migration()
        export class ${migrationName + timestamp} implements MigrationInterface {
            name = '${migrationName + timestamp}';
            
            public async up(queryRunner: QueryRunner): Promise<void> {
                const query = '';
                await queryRunner.query(query);
            }
            
            public async down(queryRunner: QueryRunner): Promise<void> {
                const query = '';
                await queryRunner.query(query);
            }
        }
    `;
}
exports.getMigrationTemplate = getMigrationTemplate;
//# sourceMappingURL=migration-template.js.map