"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRepositoryTemplate = void 0;
const dedent = require("dedent");
/**
 * Provide a basic template for the repository component generation.
 * @param repositoryName
 */
function getRepositoryTemplate(repositoryName) {
    return dedent `
        import { Repository as MedusaRepository } from "medusa-extender";
        import { EntityRepository, Repository } from "typeorm";
        
        @MedusaRepository()
        @EntityRepository(/* Specify your entity */)
        export class ${repositoryName} extends Repository</* Specify your entity */> {}
    `;
}
exports.getRepositoryTemplate = getRepositoryTemplate;
//# sourceMappingURL=repository-template.js.map