"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getServiceTemplate = void 0;
const dedent = require("dedent");
const core_1 = require("../../core");
/**
 * Provide a basic template for the service component generation.
 * @param serviceName
 */
function getServiceTemplate(serviceName) {
    const resolutionKey = (0, core_1.lowerCaseFirst)(serviceName);
    return dedent `
		import { BaseService } from "medusa-interfaces";
        import { Service } from 'medusa-extender';
        import { EntityManager } from 'typeorm';
        
        type InjectedDependencies = {
            manager: EntityManager;
        };
        
        @Service()
        export class ${serviceName} extends BaseService {
        	static resolutionKey = '${resolutionKey}';
        	
        	private readonly manager: EntityManager;
	
            constructor({ manager }: InjectedDependencies, private readonly config: any) {
            	super();
            	
            	this.manager = manager;
            }
        }
    `;
}
exports.getServiceTemplate = getServiceTemplate;
//# sourceMappingURL=service-template.js.map