"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getValidatorTemplate = void 0;
const dedent = require("dedent");
/**
 * Provide a basic template for the validator component generation.
 * @param validatorName
 */
function getValidatorTemplate(validatorName) {
    return dedent `
        import { Validator } from 'medusa-extender';
        import { AdminPostProductsReq } from '@medusajs/medusa/dist/api/routes/admin/products/create-product'
        import { IsString } from 'class-validator';
        
        @Validator({ override: /* Which validator must be overridden */ })
        export class ${validatorName} { /* extends AdminPostProductsReq { */
          @IsString()
          customField: string;
        }
    `;
}
exports.getValidatorTemplate = getValidatorTemplate;
//# sourceMappingURL=validator-template.js.map