"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createDirectoryIfNecessary = void 0;
const fs_1 = require("fs");
/**
 * Create the new directory, if necessary, that will receive the components.
 * @param relativeDestinationPath
 * @param fullDestinationPath
 * @param logger
 */
function createDirectoryIfNecessary(relativeDestinationPath, fullDestinationPath, logger = console) {
    if ((0, fs_1.existsSync)(fullDestinationPath)) {
        logger.log(`Directory ${relativeDestinationPath} already exists. Skipping directory creation`);
        return;
    }
    logger.log(`Creating directory ${fullDestinationPath}`);
    (0, fs_1.mkdirSync)(fullDestinationPath, { recursive: true });
}
exports.createDirectoryIfNecessary = createDirectoryIfNecessary;
//# sourceMappingURL=create-directory.js.map