"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseComponentValue = void 0;
const path_1 = require("path");
const core_1 = require("../../core");
/**
 * Parse the component information to create a kind of descriptor.
 * @param name
 * @param componentType
 * @param path
 * @param filePrefix
 */
function parseComponentValue(name, componentType, path = `src/modules/${name}`, filePrefix) {
    const componentFileName = `${filePrefix ? filePrefix + '-' : ''}${name}.${componentType}.ts`;
    const componentName = (0, core_1.upperCaseFirst)(name) + (0, core_1.upperCaseFirst)(componentType);
    const fullDestinationPath = (0, path_1.normalize)((0, path_1.resolve)(process.cwd(), path));
    return { relativeDestinationPath: (0, path_1.normalize)(path), fullDestinationPath, componentName, componentFileName };
}
exports.parseComponentValue = parseComponentValue;
//# sourceMappingURL=parse-component-value.js.map