/**
 * @internal
 * Internal logger to display information about the build.
 */
export declare class Logger {
    private logsQueue;
    private readonly _context;
    private readonly _app;
    get context(): string;
    get app(): string;
    constructor(context: string, app: string);
    static contextualize(context: string, app?: string): Logger;
    /**
     * Push new logs to queue and then show them later on.
     * @param description
     * @param variables
     */
    push(description: string, ...variables: string[]): this;
    /**
     * Display log immediately.
     * @param description
     * @param variables
     */
    log(description: string, ...variables: string[]): this;
    /**
     * Display warning immediately.
     * @param description
     * @param variables
     */
    warn(description: string, ...variables: string[]): this;
    /**
     * Display error logs in red immediately
     * @param description
     * @param variables
     */
    error(description: string, ...variables: string[]): this;
    /**
     * display all queues logs and then reset the queue.
     */
    flush(): this;
    /**
     * Build logs taking in count the level color
     * @param color
     * @param description
     * @param variables
     */
    private buildLog;
}
