import { InjectableComponentTypes, InjectableOptions, Type } from './types';
import { ComponentMap } from './componentMap';
/**
 * @Internal
 *
 * Read all metadata from the imported modules and extract components that will be stored by there type.
 * @param modules The modules from which the metadata are read.
 */
export declare function metadataReader(modules: Type[]): ComponentMap;
/**
 * @Internal
 *
 * Return the options from components.
 * @param component
 */
export declare function componentsMetadataReader<TComponentType = unknown>(component: Type): InjectableOptions<TComponentType> & {
    type: InjectableComponentTypes;
};
