"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.databaseLoader = void 0;
const repository_loader_1 = require("./repository.loader");
const entities_loader_1 = require("./entities.loader");
async function databaseLoader(entities, repositories) {
    const databaseLoader = await Promise.resolve().then(() => require('@medusajs/medusa/dist/loaders/database'));
    const originalDatabaseLoader = databaseLoader.default;
    databaseLoader.default = async ({ container, configModule }) => {
        await (0, entities_loader_1.entitiesLoader)(entities, container);
        await (0, repository_loader_1.repositoriesLoader)(repositories, container);
        return originalDatabaseLoader({ container, configModule });
    };
}
exports.databaseLoader = databaseLoader;
//# sourceMappingURL=database.loader.js.map