"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyAfterAuthRouters = exports.applyBeforeAuthRouters = void 0;
/**
 * @internal
 * Apply all routes on the app that must be applied before the @medusajs authentication
 * @param app
 * @param routesOptions
 */
function applyBeforeAuthRouters(app, routesOptions) {
    for (const routeOptions of routesOptions) {
        routeOptions.routes.forEach((route) => {
            if (!route.requiredAuth) {
                applyRoute(app, route);
            }
        });
    }
}
exports.applyBeforeAuthRouters = applyBeforeAuthRouters;
/**
 * @internal
 * Apply all routes on the app that must be applied after the @medusajs authentication
 * @param app
 * @param routesOptions
 */
function applyAfterAuthRouters(app, routesOptions) {
    for (const routeOptions of routesOptions) {
        routeOptions.routes.forEach((route) => {
            if (route.requiredAuth) {
                applyRoute(app, route);
            }
        });
    }
}
exports.applyAfterAuthRouters = applyAfterAuthRouters;
function applyRoute(app, route) {
    const { method, path, handlers } = route;
    app[method.toLowerCase()](path, ...handlers);
}
//# sourceMappingURL=apply-routers.js.map