"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pluginsLoadersAndListeners = void 0;
const core_1 = require("../core");
/**
 * @internal
 * Register all listeners before the plugins are loaded to be sure that the scope middleware has already been created.
 * @param app Express app
 */
async function pluginsLoadersAndListeners(app) {
    const pluginLoader = await Promise.resolve().then(() => require('@medusajs/medusa/dist/loaders/plugins'));
    const originalPluginLoader = pluginLoader.default;
    pluginLoader.default = async (cradle) => {
        app.use(async (req, res, next) => {
            req.container = cradle.container;
            await core_1.customEventEmitter.registerListeners(req.scope);
            return next();
        });
        return originalPluginLoader(cradle);
    };
}
exports.pluginsLoadersAndListeners = pluginsLoadersAndListeners;
//# sourceMappingURL=plugins.loader.js.map