"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.subscribersLoader = void 0;
const core_1 = require("../core");
const awilix_1 = require("awilix");
const logger = core_1.Logger.contextualize('SubscribersLoader');
/**
 * @internal
 * Load all custom extended validators into the underlying @medusajs instance.
 * @param subscribersOptions
 */
async function subscribersLoader(subscribersOptions) {
    logger.log('Loading custom subscribers into the underlying @medusajs');
    const module = await Promise.resolve().then(() => require('@medusajs/medusa/dist/loaders/subscribers'));
    const originalSubscriber = module.default;
    module.default = ({ container }) => {
        originalSubscriber({ container });
        subscribersOptions.forEach((subscriberOption) => {
            container.build((0, awilix_1.asFunction)((cradle) => new subscriberOption.metatype(cradle)).singleton());
        });
    };
    logger.log(`${subscribersOptions.length} subscribers built`);
}
exports.subscribersLoader = subscribersLoader;
//# sourceMappingURL=subscribers.loader.js.map