"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validatorsLoader = void 0;
const core_1 = require("../core");
const logger = core_1.Logger.contextualize('ValidatorsLoader');
/**
 * @internal
 * Load all custom extended validators into the underlying @medusajs instance.
 * @param validatorsOptions
 */
async function validatorsLoader(validatorsOptions) {
    logger.log('Loading custom validators into the underlying @medusajs');
    const module = await Promise.resolve().then(() => require('@medusajs/medusa/dist/utils/validator'));
    const originalValidator = module.validator;
    module.validator = (typedClass, plain, config) => {
        for (const validatorOptions of validatorsOptions) {
            if (validatorOptions.override.name === typedClass.name) {
                typedClass = validatorOptions.metatype;
                break;
            }
        }
        return originalValidator(typedClass, plain, config);
    };
    logger.log(`${validatorsOptions.length} validators applied`);
}
exports.validatorsLoader = validatorsLoader;
//# sourceMappingURL=validators.loader.js.map