"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TenantMiddleware = void 0;
const decorators_1 = require("../../decorators");
const tenant_service_1 = require("./tenant.service");
const awilix_1 = require("awilix");
let defaultManager;
let TenantMiddleware = class TenantMiddleware {
    async consume(req, res, next) {
        const tenantService = req.scope.resolve(tenant_service_1.TenantService.resolutionKey);
        if (!defaultManager) {
            defaultManager = req.container.registrations['manager'].resolve(req.container);
        }
        let manager;
        try {
            manager = await tenantService.getOrCreateConnection(defaultManager, req);
        }
        catch (e) {
            return next(e);
        }
        req.container.register({ manager: (0, awilix_1.asValue)(manager) });
        req.container.cache.clear();
        req.scope = req.container.createScope();
        return next();
    }
};
TenantMiddleware = __decorate([
    (0, decorators_1.Middleware)({ requireAuth: false, routes: [{ method: 'all', path: '*' }] })
], TenantMiddleware);
exports.TenantMiddleware = TenantMiddleware;
//# sourceMappingURL=tenant.middleware.js.map