import { EntityManager } from 'typeorm';
import { ConfigModule } from './types';
import { MedusaRequest } from '../../core';
import TenantRepository from './tenant.repository';
declare type ConstructorParams = {
    tenantRepository: typeof TenantRepository;
};
export declare class TenantService {
    #private;
    private readonly container;
    private readonly config;
    static readonly resolutionKey = "tenantService";
    constructor(container: ConstructorParams, config: ConfigModule);
    /**
     * Provide a way to switch between database connections depending on the request property holding the tenant code.
     * @param defaultManager
     * @param req
     */
    getOrCreateConnection(defaultManager: EntityManager, req: MedusaRequest): Promise<EntityManager>;
}
export {};
